// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

#define MAX_REGISTERS				10				// maximum number of registers that will be remembered

typedef struct compiledExpression COMPILED_EXPRESSION;

void REFree(COMPILED_EXPRESSION *expression);
void REPrintCompiledExpression(COMPILED_EXPRESSION *expression);
COMPILED_EXPRESSION *RECompile(UINT8 *expression,UINT32 numBytes,const UINT8 *translateTable);
bool GetRERegisterMatch(COMPILED_EXPRESSION *compiledExpression,UINT32 expRegisterIndex,UINT32 *matchOffset,UINT32 *matchLength);
bool GetRERegisterMatchChunkAndOffset(COMPILED_EXPRESSION *compiledExpression,UINT32 expRegisterIndex,CHUNK_HEADER **chunk,UINT32 *offset,UINT32 *matchLength);
bool SearchForwardRE(CHUNK_HEADER *chunk,UINT32 offset,COMPILED_EXPRESSION *compiledExpression,bool leftEdge,bool rightEdge,UINT32 numToSearchStart,UINT32 numToSearch,bool ignoreCase,bool *foundMatch,UINT32 *matchOffset,UINT32 *numMatched,CHUNK_HEADER **startChunk,UINT32 *startOffset,CHUNK_HEADER **endChunk,UINT32 *endOffset,ABORT_TEST_FUNCTION *abortFunction);
bool SearchBackwardRE(CHUNK_HEADER *chunk,UINT32 offset,COMPILED_EXPRESSION *compiledExpression,bool leftEdge,bool rightEdge,UINT32 numToSearchStart,UINT32 numToSearch,bool ignoreCase,bool *foundMatch,UINT32 *matchOffset,UINT32 *numMatched,CHUNK_HEADER **startChunk,UINT32 *startOffset,CHUNK_HEADER **endChunk,UINT32 *endOffset,ABORT_TEST_FUNCTION *abortFunction);
void REHuntBackToFarthestPossibleStart(CHUNK_HEADER *chunk,UINT32 offset,COMPILED_EXPRESSION *compiledExpression,UINT32 *numBack,CHUNK_HEADER **endChunk,UINT32 *endOffset);
