// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

typedef struct expressionPiece EXPRESSION_PIECE;
typedef struct expressionPieceList EXPRESSION_PIECE_LIST;
typedef struct syntaxExpression SYNTAX_EXPRESSION;
typedef struct syntaxStyleMapping SYNTAX_STYLE_MAPPING;
typedef struct syntaxStyleMappingList SYNTAX_STYLE_MAPPING_LIST;
typedef struct syntaxMap SYNTAX_MAP;

bool UpdateSyntaxInformation(EDITOR_BUFFER *buffer,UINT32 startOffset,UINT32 endOffset,UINT32 numBytes);
bool RegenerateAllSyntaxInformation(EDITOR_BUFFER *buffer);
SYNTAX_MAP *GetInstanceParentMap(SYNTAX_INSTANCE *instance);
void CloseSyntaxInstance(SYNTAX_INSTANCE *instance);
SYNTAX_INSTANCE *OpenSyntaxInstance(SYNTAX_MAP *map,EDITOR_BUFFER *buffer);
void RemoveMappingList(SYNTAX_STYLE_MAPPING_LIST *list);
SYNTAX_STYLE_MAPPING_LIST *AddMappingListElement(SYNTAX_STYLE_MAPPING_LIST **listHead,SYNTAX_STYLE_MAPPING *mapping);
SYNTAX_STYLE_MAPPING_LIST *AddBetweenListElementToMapping(SYNTAX_STYLE_MAPPING *mapping,SYNTAX_STYLE_MAPPING *betweenMapping);
SYNTAX_STYLE_MAPPING_LIST *AddRootListElementToMap(SYNTAX_MAP *map,SYNTAX_STYLE_MAPPING *rootMapping);
SYNTAX_STYLE_MAPPING *LocateSyntaxStyleMapping(SYNTAX_MAP *map,const char *name);
void SetMappingStartExpressionPiece(SYNTAX_STYLE_MAPPING *mapping,EXPRESSION_PIECE *startExpressionPiece);
void RemoveExpressionList(EXPRESSION_PIECE_LIST *list);
EXPRESSION_PIECE_LIST *AddMappingEndExpressionPiece(SYNTAX_STYLE_MAPPING *mapping,EXPRESSION_PIECE *endExpressionPiece);
void SetMappingStyles(SYNTAX_STYLE_MAPPING *mapping,UINT32 startStyle,UINT32 betweenStyle,UINT32 endStyle);
void RemoveMappingFromSyntaxMap(SYNTAX_MAP *map,SYNTAX_STYLE_MAPPING *mapping);
SYNTAX_STYLE_MAPPING *AddMappingToSyntaxMap(SYNTAX_MAP *map,const char *mappingName);
EXPRESSION_PIECE *LocateExpressionPiece(SYNTAX_EXPRESSION *expression,bool useRegisterMatch,UINT32 registerIndex);
void RemovePieceFromExpression(SYNTAX_EXPRESSION *expression,EXPRESSION_PIECE *piece);
EXPRESSION_PIECE *AddPieceToExpression(SYNTAX_EXPRESSION *expression,bool useRegisterMatch,UINT32 registerIndex);
SYNTAX_EXPRESSION *LocateSyntaxMapExpression(SYNTAX_MAP *map,const char *name);
void RemoveExpressionFromSyntaxMap(SYNTAX_MAP *map,SYNTAX_EXPRESSION *expression);
SYNTAX_EXPRESSION *AddExpressionToSyntaxMap(SYNTAX_MAP *map,const char *expressionName,const char *expressionText);
char *GetSyntaxMapName(SYNTAX_MAP *map);
SYNTAX_MAP *LocateNextSyntaxMap(SYNTAX_MAP *map);
SYNTAX_MAP *LocateSyntaxMap(char *name);
void UnlinkSyntaxMap(SYNTAX_MAP *map);
bool LinkSyntaxMap(SYNTAX_MAP *map);
void CloseSyntaxMap(SYNTAX_MAP *map);
SYNTAX_MAP *OpenSyntaxMap(char *name);
EDITOR_BUFFER *LocateNextEditorBufferOnMap(SYNTAX_MAP *map,EDITOR_BUFFER *buffer);
SYNTAX_MAP *GetAssignedSyntaxMap(EDITOR_BUFFER *buffer);
bool AssignSyntaxMap(EDITOR_BUFFER *buffer,SYNTAX_MAP *map);
void UnInitSyntaxMaps();
bool InitSyntaxMaps();
