// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

typedef void buttonResizeFunction(EDITOR_WINDOW *dialog,EDITOR_RECT *newRect);

typedef struct buttonDescriptor									// describes a button to creation routines
{
	buttonResizeFunction
		*resizeFunction;										// function which is used to resize for this window
	const char
		*buttonName;
	const char
		*fontName;
	bool
		hasKey;													// true if this button has a key code associated with it
	KeySym
		keySym;													// equivalent key code for this button
	bool
		*pressedState;											// boolean set to true if button pressed
	void
		(*pressedProc)(void *parameters);						// routine called when the button has been pressed
	void
		*pressedProcParameters;									// data passed to pressedProc routine
} BUTTON_DESCRIPTOR;

void PressButtonItem(DIALOG_ITEM *item);
bool CreateButtonItem(DIALOG_ITEM *item,void *descriptor);
