// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".


#define	EDIT_MIN_WIDTH			100
#define	EDIT_MAX_WIDTH			((1<<30)-1)
#define	EDIT_MIN_HEIGHT			100
#define	EDIT_MAX_HEIGHT			((1<<30)-1)

#define	H_SCROLL_MAX_WIDTH		32767	// maximum width handled by the horizontal scroll bar

#define EDIT_TOP_BORDER			0		// the view of an edit window is offset by these borders (strictly for looks)
#define EDIT_BOTTOM_BORDER		0
#define EDIT_LEFT_BORDER		0
#define EDIT_RIGHT_BORDER		0

#define	STATUS_BAR_LINE_HEIGHT	2

void AdjustDocumentWindowStatus(EDITOR_WINDOW *window);
void UpdateDocumentWindow(EDITOR_WINDOW *window);
void AdjustDocumentWindowForNewSize(EDITOR_WINDOW *window);
void DocumentWindowButtonPress(EDITOR_WINDOW *window,XEvent *event);
void DocumentPeriodicProc(EDITOR_WINDOW *window);
void DocumentWindowEvent(EDITOR_WINDOW *window,XEvent *event);
void ScrollEditViewEvent(EDITOR_VIEW *view,UINT32 eventCode,bool repeating);
void MinimizeDocumentWindow(EDITOR_WINDOW *window);
void UnminimizeDocumentWindow(EDITOR_WINDOW *window);
void SetTopDocumentWindow(EDITOR_WINDOW *window);
EDITOR_WINDOW *GetActiveDocumentWindow();
EDITOR_WINDOW *GetTopDocumentWindow();
bool GetSortedDocumentWindowList(UINT32 *numElements,EDITOR_WINDOW ***list);
EDITOR_VIEW *GetDocumentWindowCurrentView(EDITOR_WINDOW *window);
bool GetDocumentWindowTitle(EDITOR_WINDOW *window,char *title,UINT32 stringBytes);
bool SetDocumentWindowTitle(EDITOR_WINDOW *window,const char *title);
bool GetEditorDocumentWindowForegroundColor(EDITOR_WINDOW *window,EDITOR_COLOR *foregroundColor);
bool SetEditorDocumentWindowForegroundColor(EDITOR_WINDOW *window,EDITOR_COLOR foregroundColor);
bool GetEditorDocumentWindowBackgroundColor(EDITOR_WINDOW *window,EDITOR_COLOR *backgroundColor);
bool SetEditorDocumentWindowBackgroundColor(EDITOR_WINDOW *window,EDITOR_COLOR backgroundColor);
bool GetEditorDocumentWindowRect(EDITOR_WINDOW *window,EDITOR_RECT *rect);
bool SetEditorDocumentWindowRect(EDITOR_WINDOW *window,EDITOR_RECT *rect);
EDITOR_WINDOW *OpenDocumentWindow(EDITOR_BUFFER *buffer,EDITOR_RECT *rect,char *title,char *fontName,UINT32 tabSize,EDITOR_COLOR foreground,EDITOR_COLOR background);
void CloseDocumentWindow(EDITOR_WINDOW *window);
