// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

typedef void listBoxResizeFunction(EDITOR_WINDOW *dialog,EDITOR_RECT *newRect);

typedef struct listBoxDescriptor		// describes a list box to creation routines
{
	listBoxResizeFunction
		*resizeFunction;				// function which is used to resize for this window
	EDITOR_COLOR
		focusBackgroundColor,			// color to use when drawing background during focus
		focusForegroundColor,			// color to use when drawing foreground during focus
		nofocusBackgroundColor,			// color to use when drawing background during non focus
		nofocusForegroundColor;			// color to use when drawing foreground during non focus
	UINT32
		numElements;					// tells how many elements are in the list
	const char
		**listElements;					// pointer to NULL terminated array of pointers to items in the list
	bool
		*selectedElements;				// pointer to array of bools which tell which items should be selected at startup
	UINT32
		topLine;						// tells which line is displayed at the top of the list box when it opens
	const char
		*fontName;						// name of font to use for list items
	void
		(*pressedProc)(void *parameters);	// routine called when the list items have been chosen (by double clicking in the list)
	void
		*pressedProcParameters;			// data passed to pressedProc routine
} LIST_BOX_DESCRIPTOR;


void ResetListBoxItemLists(DIALOG_ITEM *item,UINT32 numElements,const char **list,bool *selectedElements);
bool CreateListBoxItem(DIALOG_ITEM *item,void *descriptor);
