// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".


const char *GetEditorLocalVersion();
bool PointInRECT(INT32 x,INT32 y,EDITOR_RECT *rect);
void GlobalToLocal(Window xWindow,INT32 x,INT32 y,INT32 *outX,INT32 *outY);
void LocalToGlobal(Window xWindow,INT32 x,INT32 y,INT32 *outX,INT32 *outY);
void EditorBeep();
void ReportMessage(const char *format,...);
void ShowBusy();
void ShowNotBusy();
char *CreateWindowTitleFromPath(const char *absolutePath);
char *realpath2(const char *path,char *outputPath);
char *CreateAbsolutePath(const char *relativePath);
bool LocateStartupScript(char *scriptPath);
EDITOR_FILE *OpenEditorReadFile(const char *path);
EDITOR_FILE *OpenEditorWriteFile(const char *path);
bool ReadEditorFile(EDITOR_FILE *file,UINT8 *buffer,UINT32 bytesToRead,UINT32 *bytesRead);
bool WriteEditorFile(EDITOR_FILE *file,UINT8 *buffer,UINT32 bytesToWrite,UINT32 *bytesWritten);
void CloseEditorFile(EDITOR_FILE *file);
void OutlineShadowRectangle(Window xWindow,EDITOR_RECT *rect,EDITOR_COLOR upperLeftColor,EDITOR_COLOR lowerRightColor,UINT32 thickness);
