// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

typedef void staticTextResizeFunction(EDITOR_WINDOW *dialog,EDITOR_RECT *newRect);

typedef struct staticTextDescriptor								// describes static text to creation routines
{
	staticTextResizeFunction
		*resizeFunction;										// function which is used to resize for this window
	EDITOR_COLOR
		backgroundColor,										// color to use when drawing background
		foregroundColor;										// color to use when drawing foreground
	const char
		*string;
	const char
		*fontName;
} STATIC_TEXT_DESCRIPTOR;

void ResetStaticTextItemText(DIALOG_ITEM *item,char *newString);
bool CreateStaticTextItem(DIALOG_ITEM *item,void *description);
