// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

typedef void textBoxResizeFunction(EDITOR_WINDOW *dialog,EDITOR_RECT *newRect);

typedef struct textBoxDescriptor		// describes a list box to creation routines
{
	EDITOR_BUFFER
		*buffer;						// the buffer on which to view
	textBoxResizeFunction
		*resizeFunction;				// function which is used to resize for this window
	UINT32
		topLine;
	INT32
		leftPixel;
	UINT32
		tabSize;
	EDITOR_COLOR
		focusBackgroundColor,			// color to use when drawing background when it has focus
		focusForegroundColor,			// color to use when drawing foreground when it has focus
		nofocusBackgroundColor,			// color to use when drawing background when it does not have focus
		nofocusForegroundColor;			// color to use when drawing foreground when it does not have focus
	char
		*fontName;						// name of font to use
} TEXT_BOX_DESCRIPTOR;

bool CreateTextBoxItem(DIALOG_ITEM *item,void *descriptor);
